function [peak_SAR] = calculate_peak_SAR(params)

% Searches for the peak SAR on a predefined rectilinear grid

Peak_loss = 0;

Eint = 0;
% compute coefficients
result = Mie_cd(params.x0,params.m, params);
c=result(1,:);
d=result(2,:);

%% init progress bar
wb = waitbar(0,'Calculating peak SAR');

%%
resolution = params.resolution;
x_vec = params.x_grid;
y_vec = params.y_grid;
z_vec = params.z_grid;

% step x,y,z coordinates
for x_index = 1:length(x_vec)
    x = x_vec(x_index);
    % update waitbar
    wb = waitbar((x_index)/length(x_vec),wb);
    %     round(100*(x_index)/length(x_vec))
    for y_index = 1:length(y_vec)
        y = y_vec(y_index);
        for z_index = 1:length(z_vec)
            z = z_vec(z_index);
            
            % coordinate conversion from cartesian to spherical
            rc = sqrt(x^2+y^2+z^2);
            theta = atan2(sqrt(x^2+y^2), z);
            phi = atan2(y,x);
            
            % omit calculation outside sphere
            if((rc) > params.a )
                E_field_sph = [0 0 0];
            else
                E_field_sph = computeE1atSphCoords(rc, theta, phi, c, d,  params);
                
                % search for maximum               
                if(Peak_loss < sum(abs(E_field_sph).^2))
                    Peak_loss = sum(abs(E_field_sph).^2);
                end
                Eint = Eint + resolution^3 * sum(abs(E_field_sph).^2);
            end
            
        end
    end
end
close(wb)
%%
peak_SAR = Peak_loss * params.sigma / params.density / 2;
