function intArg = integralArgumentOfBessel(n, r, c, d, params)
% Calculate the argument of the 1D integral in r

rho = r * params.k0 * params.m;               

bj = sphbes(n, rho, params);
Mn = 2*pi() * (2*n+1) * abs(bj)^2;

bj_rho = sphbes_per_x(n, rho, params);
Sn = 2*pi() * n*(n+1)*(2*n+1) * abs(bj_rho)^2;

d_bj_rho = d_x_sphbes_per_x(n, rho, params);
Nn = 2*pi() * (2*n+1) * abs(d_bj_rho)^2;

intArg = params.E0^2 * ( abs(c(n))^2 * Mn + abs(d(n))^2 * (Sn + Nn) );

end