%---------------------------------------------------------
% save grid indexes and points; indexes (i,j,k) start at 0
%---------------------------------------------------------

function nofGPoints = saveGrid(params,fileName)

%
wb = waitbar(0,'Grid generation');


x_vec = params.x_grid;
y_vec = params.y_grid;
z_vec = params.z_grid;

%

num_grid_points = length(x_vec)*length(y_vec)*length(z_vec);
current_grid_point = 1;
IJK = zeros(num_grid_points,3);
XYZ = zeros(num_grid_points,3);


% step x,y,z coordinates
for x_index = 1:length(x_vec)
    x = x_vec(x_index);
    wb = waitbar((x_index)/length(x_vec),wb);
    
    for y_index = 1:length(y_vec)
        y = y_vec(y_index);
        for z_index = 1:length(z_vec)
            z = z_vec(z_index);
            
            % GRID
            IJK(current_grid_point,1) = x_index-1;
            IJK(current_grid_point,2) = y_index-1;
            IJK(current_grid_point,3) = z_index-1;
            XYZ(current_grid_point,1) = x;
            XYZ(current_grid_point,2) = y;
            XYZ(current_grid_point,3) = z;
            
            current_grid_point = current_grid_point+1;
        end
    end
end



% open file
fid = fopen(fileName, 'wt');

nofXYZ = size(XYZ(:,1));
nofIJK = size(IJK(:,1));
if(nofXYZ(1) ~= nofIJK(1))
    close(wb);
    fclose(fid);
    assert( nofXYZ(1) == nofIJK(1), 'Data is not consistent!');
    return;
end

nofGPoints = nofXYZ(1);

for m = 1:nofGPoints
        fprintf(fid, '%d\t%d\t%d\t', IJK(m,1), IJK(m,2), IJK(m,3) );
        fprintf(fid, '%14.7e\t%14.7e\t%14.7e\n', XYZ(m,1), XYZ(m,2), XYZ(m,3) );
end

fclose(fid);
close(wb)

end