%---------------------------------------------------------
% compute exact Hx field component in Layered cube
%---------------------------------------------------------

function Hx = computeExactHx_Layered(params, y)

E0 = params.E0;
eta0 = params.eta0;
k0 = params.k0;
eta1 = params.eta1;
k1 = params.k1;
seps = sqrt(params.eps_r1);
h = params.h;

% compute reflection constants
jk0h = complex(0,k0*h);
jk1h = complex(0,k1*h);
A0 = E0 * exp(-2*jk0h) * (1-seps) / (1+seps);
A1 = 2*E0 / (1+seps) * exp(-jk0h) / exp(-jk1h);

% calculate Ez
Hx = complex(0,0);
if y < h 
    jk0y = complex(0,k0*y);
    Hx = E0 / eta0 * exp(-jk0y) - A0 / eta0 * exp(jk0y);
else
    jk1y = complex(0,k1*y);
    Hx = A1 / eta1 * exp(-jk1y);
end

end